/*
 * $Id$
 *
 * [ Description ]
 * 
 */

#include "Behavioural/include/Interfaces.h"


namespace morpheo              {
namespace behavioural          {

#undef  FUNCTION
#define FUNCTION "Interfaces::get_interface"
  string Interfaces::get_interface (void)
  {
    log_printf(FUNC,Behavioural,FUNCTION,"Begin");

    uint32_t               depth          = 0;
    string                 separator      = "\n";
    bool                   last_separator = false;

    list<Interface_fifo*>::iterator i  = _list_interface->begin();
    bool                   empty = _list_interface->empty();

    string                 tab   = string(depth,'\t');
    ostringstream          text;

    if (not empty)
      {
	// First
	if (i != _list_interface->end())
	  {
	    text << tab << **i;
	    ++i;
	  }
	
	while (i != _list_interface->end())
	  {
	    text << separator;
	    text << tab << **i;
	    ++i;
	  }
	
	if (last_separator)
	  text << separator;
      }

    log_printf(FUNC,Behavioural,FUNCTION,"End");
    
    return text.str();
  };

#undef  FUNCTION
#define FUNCTION "Interfaces::get_interface_list"
  list<Interface_fifo*>* Interfaces::get_interface_list (void)
  {
    log_printf(FUNC,Behavioural,FUNCTION,"Begin");
    list<Interface_fifo*>* _return =  _list_interface;
    log_printf(FUNC,Behavioural,FUNCTION,"End");

    return _return;
  };

}; // end namespace behavioural          
}; // end namespace morpheo              
